/*globals define*/

define([
    'testsuite/qunit',
    'jquery',
    'de_epages/shopmailtype/ui/placeholderdialog',
    'testsuite/qunit-fixture!de_epages/shopmailtype/ui/placeholderdialog-test',

    '$ready!'
], function (QUnit, $, de_epages, fixture) {
    'use strict';

    QUnit.module("de_epages/shopmailtype/ui/placeholderdialog", {
        setup: function () {
            fixture.init();
        },

        teardown: function () {
            fixture.destroy();
        }
    });

    QUnit.test("de_epages/shopmailtype/ui/placeholderdialog", function () {

        // Check prototype methods.
        $.each(['_create', '_setOption', 'destroy', '_close', '_onTrClick'], function (i, fn) {
            QUnit.equal(
                $.isFunction($.ui.shopmailtypeUiPlaceholderdialog.prototype[fn]),
                true,
                '$.isFunction(' + fn + '):'
            );
        });

        // Create placeholder.
        var $insertPlaceHolder = $('#ep-insertPlaceHolder').shopmailtypeUiPlaceholderdialog();

        QUnit.equal(
            typeof $insertPlaceHolder.data('de_epagesShopmailtypeUiPlaceholderdialog') === 'object',
            true,
            "typeof $insertPlaceHolder.data('de_epagesShopmailtypeUiPlaceholderdialog') === 'object'"
        );

        // Open dialog.
        $insertPlaceHolder.trigger('click');

        // Click tr. (Insert first placeholder.)
        $($('table tr').get(0)).trigger('click');

        QUnit.equal(
            $('input[name="Subject"]').val(),
            "#Code0My subject is so pretty",
            '*Placeholder0* inserted at beginning of input with name "Subject"'
        );

        // Change selection in input.
        $('input[name="Subject"]')
            .prop({
                'selectionStart' : 9,
                'selectionEnd' :  16
            });

        // Click tr. (Insert second placeholder.)
        $($('table tr').get(1)).trigger('click');

        QUnit.equal(
            $('input[name="Subject"]').val(),
            "#Code0My #Code1 is so pretty",
            '*Placeholder1* inserted at previous position of "Subject" in input with name "Subject"'
        );

        // Destroy.
        $('#ep-insertPlaceHolder').shopmailtypeUiPlaceholderdialog('destroy');

        QUnit.equal(
            $insertPlaceHolder.data('epUiSimpledialog'),
            undefined,
            '*uiSimpledialog* data attribute removed'
        );

        QUnit.deepEqual(
            $insertPlaceHolder.data('de_epagesShopmailtypeUiPlaceholderdialog'),
            $.parseJSON($insertPlaceHolder.attr('data-de_epages-shopmailtype-ui-placeholderdialog') || "null"),
            '*shopmailtypeUiPlaceholderdialog* data attribute removed'
        );
    });
});